/*============================================================================
|   Copyright (C) 2001-2003  Jonathan Harm
|
|
|   This program is free software; you can redistribute it and/or
|   modify it under the terms of the GNU General Public License
|   as published by the Free Software Foundation; either version 2
|   of the License, or (at your option) any later version.
|   This program is distributed in the hope that it will be useful,
|   but WITHOUT ANY WARRANTY; without even the implied warranty of
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|   GNU General Public License for more details.
|   You should have received a copy of the GNU General Public License
|   along with this program; if not, write to the Free Software
|
|   Foundation, Inc.,
|   59 Temple Place - Suite 330
|   Boston, MA  02111-1307, USA.
|
|
|
|                   gettable.c REV 4 for SQL Query Generator
|
|  This program is under the GPL see http://www.gnu.org for more info
|
|
|                   http://change.to/opensource
|                   110983@lycos.com
|
\============================================================================*/
#include "querygen.h"

char *gettable( FILE *fp)
{



      char *p_tablename;
      static char tablename[MAX];       //return pointer to array
      char user_input[MAX];              //what the user types in for tablename, use this instead of tablename in case
                                                    //the user just presses enter for the default table.

      char tmp_buffer[MAX];                     //upper case buffer(easier to use for checking for types)
      char tmp_tablename[MAX];
      int i;                                          //for counting





rewind(fp);  //rewind so gettable() can return a list of tables to the user every time they create a query
                 //so they can create queries for different tables.

printf("\n\nTable name\n\n");



while( (p_tablename = skipcomment(fp)) != NULL)
{

    //make the tmp_buffer buffer upper case
  strcpy(tmp_buffer, p_tablename);
  for(i = 0; i < MAX; i++) {

        tmp_buffer[i] = toupper(tmp_buffer[i]);

  }


       if( strcmp(tmp_buffer, "CREATE") == 0 )
       {


             //get the next thing from the file
             if( (p_tablename = skipcomment(fp)) == NULL)
               exit(1);
                 //make the tmp_buffer buffer upper case
                 strcpy(tmp_buffer, p_tablename);
                 for(i = 0; i < MAX; i++){ tmp_buffer[i] = toupper(tmp_buffer[i]); }


             if( strcmp(tmp_buffer,"TABLE") == 0 )  {


                 if( (p_tablename = skipcomment(fp)) != NULL) { //this has to be the table name

                  //before returning the table name,
                 //we need to get past the '('
                 memset(tmp_tablename, '\0', MAX);
                 memset(tmp_buffer, '\0', MAX);
                 strcpy(tmp_buffer, p_tablename);
             

                   
       		 if(strchr(tmp_buffer, '(') != NULL)
       		 {  
                  i = 0;
       		    while(tmp_buffer[i] != '(')
       		    { tmp_tablename[i] = tmp_buffer[i];  i++;}
                             
       		      while(tmp_buffer[i] != '\0') i++; //count how many chars until NULL
                     i = (i - strlen(tmp_tablename)); 

                
	                 //now set cursor back to where it should be
		             fseek(fp, -(long)i, SEEK_CUR);
    
       		 }


          
       		 //we didn't find '(' yet so skipcomment one more time
       		 else
       		 {      strcpy(tmp_tablename, tmp_buffer); //copy to tmp_tablename before using it below                    
              		  if((p_tablename = skipcomment(fp)) != NULL)
                         strcpy(tmp_buffer, p_tablename);
              		    if(strchr(tmp_buffer, '(') == NULL) //look for '(' right after the table name
              		     { fprintf(stderr, "Missing '(' after table name\n"); exit(1); }

                    

                    else if(strlen(tmp_buffer) > 1) //count how many chars are after '(' if any
              		     {      i = 0; while(tmp_buffer[i] != '\0') i++;
                                             
	                          	      //now set cursor back to where it should be
		                              fseek(fp, -(long)i, SEEK_CUR);                            
		                  }


                }


                   //chkres requires a pointer so copy tmp_tablename to p_tablename
		        p_tablename = &tmp_tablename[0];
              

                    //now we have the table name
                    //but before returning it, check for reseverd words
                       if( chkres(p_tablename) == 0)
                        printf("%s\n", p_tablename); //print the table name to the screen


                      else
                       {
                         fprintf(stderr, "\nERROR: %s is a reserved word.\n", p_tablename);
                          exit(1);
                       }


                   } //end of if( (p_tablename = skipcomment(fp)) != NULL)

           }  // end of   if( strcmp(p_tablename,"TABLE") == 0 )

           else{ fprintf(stderr, "Error in your CREATE TABLE query file\n"); exit(1); }
        }     // end of   if( strcmp(p_tablename, "CREATE"))



  }//end of while loop

  printf("\nType in the name of the table you want to make a query for [%s] ", tablename);

  fgets(user_input, MAX, stdin); //this is where the user types in the table they want to make a query for
  user_input[strlen(user_input)-1] = '\0'; //put the null at the end

   //if the user didn't enter a table name, return NULL so
   //the function that called gettable() can close the files

      //if the user does not press enter and types in the table name,
   //then copy user_input to tablename before it is returned
   if(user_input[0] != '\0')
     strcpy(tablename, user_input);




   return tablename;


/*   if((strcmp(tablename, "") == 0) && user_input[0] == '\0')  //this only happens the first time this function is called
     return NULL;

   else if(  (strcmp(tablename, "") != 0) && user_input == '\0') //if the user pressed enter to use the last tablename typed
     return tablename;

   else if(user_input[0] != '\0') //and if the user entered something
     strcpy(tablename, user_input);
     return tablename;
  */

}
