/*============================================================================ 
|   Copyright (C) 2003  Jonathan Harm                                           
| 
| 
|   This program is free software; you can redistribute it and/or 
|   modify it under the terms of the GNU General Public License 
|   as published by the Free Software Foundation; either version 2 
|   of the License, or (at your option) any later version. 
|   This program is distributed in the hope that it will be useful, 
|   but WITHOUT ANY WARRANTY; without even the implied warranty of 
|   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
|   GNU General Public License for more details. 
|   You should have received a copy of the GNU General Public License 
|   along with this program; if not, write to the Free Software 
|    
|   Foundation, Inc.,  
|   59 Temple Place - Suite 330 
|   Boston, MA  02111-1307, USA. 
| 
|   
| 
|                   gototable.c INITIAL For SQL Query Generator
| 
|  This program is under the GPL see http://www.gnu.org for more info 
| 
|   
|                   http://change.to/opensource 
|                   110983@lycos.com 
| 
\============================================================================*/ 

#include "querygen.h"


int gototable(FILE *fpctq, char *tablename) {

           char *p_ctqbuf;
           char tablecheck[MAX];
           char tmp_tablename[MAX];
           int i;

                   //Advance to the right spot in fpctq
                         rewind(fpctq);
                   //first get to the part of the fpctq file that creates
                   //the columns for the table that the user wants
                  //to make a query for


        while ((p_ctqbuf = skipcomment(fpctq))  != NULL)
        {

            //need to strip ( off of pctqbuf if it is the last character


            if(strstr(p_ctqbuf, tablename) != NULL)
            {                 memset(tablecheck, '\0', MAX);
            memset(tmp_tablename, '\0', MAX);
            strcpy(tablecheck, p_ctqbuf);
                          if(strchr(tablecheck, '(') != NULL)
                      	  {
                                 i = 0;
                      		    while(tablecheck[i] != '(')
                      		    { tmp_tablename[i] = tablecheck[i];  i++;}

                      		      while(tablecheck[i] != '\0') i++; //count how many chars until NULL
                                    i = (i - strlen(tmp_tablename));

               	                 //now set cursor back to where it should be
               		             fseek(fpctq, -(long)i, SEEK_CUR);
                               
                                  return 0;    

                      		 }



                      		 //we didn't find '(' yet so skipcomment one more time
                      		 else
                      		 {      strcpy(tmp_tablename, tablecheck); //copy to tmp_tablename before using it below
                                     
                             		  if((p_ctqbuf = skipcomment(fpctq)) != NULL)  //just skipcomment once and '(' must be the next char
                                        strcpy(tablecheck, p_ctqbuf);
                             		    if(strchr(tablecheck, '(') == NULL) //look for '(' right after the table name
                             		     { fprintf(stderr, "Missing '(' after table name\n"); exit(1); }

                                   else if(strlen(tablecheck) > 1) //count how many chars are after '(' if any
                             		     {   i = 0; while(tablecheck[i] != '\0') i++;
                                                                                                      
                                          //now set cursor back to where it should be
        		                              fseek(fpctq, -(long)i, SEEK_CUR);
                                             return 0;  //return 0 after backtracking to the first character of the first column name after the '('
               		                  }


                                      else return 0; //return 0 if '(' was found by itself
                                   
                               }



                         
               }   //end of   if(strstr(p_ctqbuf, tablecheck) != NULL)

               
        } //end of while loop

   return 1;

}
